/******************************************************************************

SPAMIHILATOR - PLUGIN SDK 2.5
(c)2003-2004 Michel Krmer

plugins_spamcheck - header file

All FILES IN THIS PACKAGE ARE RELEASED UNDER THE TERMS OF THE SPAMIHILATOR
LICENSE INCLUDING THE FOLLOWING TERM THAT IS CONTRARY TO THE LICENSE:

  You are allowed to distribute verbatim copies of this SDK, but you are not
allowed to change/modify files in this package.
Futhermore you are allowed to use parts of the sample plugin's source code 
in your own Plugins as far as you make your Plugins avalibale for free and
do not charge for it or for the service of distribution!

  This file is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the Spamihilator License for more details.

  You should have received a copy of the Spamihilator license along with this
file; if not, goto www.spamihilator.com

******************************************************************************/


#ifndef __plugins_spamcheck_h__
#define __plugins_spamcheck_h__

#define MAKEVERSION(major, minor, revision) ((major << 16) + (minor << 8) + revision)

struct MSGHDRFIELD
{
	char *name;
	char *body;
	unsigned short flags;

	MSGHDRFIELD* next;
};

struct MSGHDR
{
	MSGHDRFIELD *fieldlist;
};

typedef int  (* LPINITFUNC)  ();
typedef void (* LPFREEFUNC)  ();
typedef void (* LPCONFIGFUNC)(HWND parent);

typedef int  (* LPISSPAMFUNC_HDR)   (unsigned int id, const MSGHDR *header,  double *probability);
typedef int  (* LPISSPAMFUNC_HTML)  (unsigned int id, const char   *message, double *probability);
typedef int  (* LPISSPAMFUNC_NOHTML)(unsigned int id, const char   *message, double *probability);
typedef int  (* LPISSPAMFUNC)       (unsigned int id, const char   *message, double *probability);

struct SPAMCHECKPLUGININFO
{
	long version;        //plugin's version
	long version_needed; //Spamihilator version needed

	char name[80];       //plugin name
	char author[80];     //author (+ optional mail address)
	char desc[80];       //very short plugin description

	LPINITFUNC   init;   //initialize the plugin - returns 0 on success
	LPFREEFUNC   free;   //free plugin
	LPCONFIGFUNC config; //show a configuration dialog or something like that

	//check for spam
	//  return values:
	//    -1 : Spam!
	//     0 : unsure
	//     1 : Non-Spam
	LPISSPAMFUNC_HDR     isSpamHdr;      //message header
	LPISSPAMFUNC_HTML    isSpamHtml;     //message text containing html
	LPISSPAMFUNC_NOHTML  isSpamNoHtml;   //message text without html
	LPISSPAMFUNC         isSpam;         //complete message
};

typedef SPAMCHECKPLUGININFO *(* LPGETSPAMCHECKPLUGININFOFUNC)();

#endif